package application

import "git.squidspirit.com/squid/blog.git/backend/internal/domain"

type GetAllPostsUseCase interface {
	Execute() ([]*domain.Post, error)
}

type getAllPostsUseCaseImpl struct {
	postRepo PostRepo
}

func NewGetAllPostsUseCase(postRepo PostRepo) GetAllPostsUseCase {
	return &getAllPostsUseCaseImpl{
		postRepo: postRepo,
	}
}

func (uc *getAllPostsUseCaseImpl) Execute() ([]*domain.Post, error) {
	return uc.postRepo.GetAll()
}
